import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class PictureCanvas extends ScaleCanvas implements MouseListener, MouseMotionListener {
    Manager M;
    Path2D.Double GP;

     public PictureCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 setScales(300,300,50);
	 GP=new Path2D.Double();	
     }

   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      drawBG(g);
      if(M.C.CHO.val==0) drawCube(g);
      if(M.C.CHO.val==1) drawSlice(g);
      if(M.C.CHO.val==2) {
	  drawSlice(g);
	  drawCube(g);
      }
   }


    public void scaleNicely(Path2D.Double gp) {
	if(M.C.FIT.val==0) return;
	AffineTransform[] AA=preFit(gp,10,10,getWidth()-20,getHeight()-20);
	A[0]=AA[0];
	A[1]=AA[1];
    }


    public void drawBG(Graphics2D g) {
	g.setColor(Color.blue);
	g.fillRect(0,0,getWidth(),getHeight());
	g.setColor(Color.black);
	g.fillRect(10,10,getWidth()-20,getHeight()-20);
	g.setColor(new Color(0,0,120));
	g.drawRect(10,10,getWidth()-20,getHeight()-20);
    }

    public void scaleCube() {
	Path2D.Double gp=new Path2D.Double();
	int d=M.C.S.val;
	double lim=Math.pow(2,d);
	for(int n=0;n<lim;++n) {
	    for(int nn=0;nn<d;++nn) {
		Complex[] Z=CubeMaker.edgeProject(d,n,nn,M.C.NAV);
		gp.moveTo(Z[0].x,Z[0].y);
		gp.lineTo(Z[1].x,Z[1].y);

	    }
	}
	scaleNicely(gp);
      }

    public void drawSlice(Graphics2D g) {
	Path2D.Double gp=CubeSlicer.slice(M.C.S.val,M.C.NAV);
	//scaleNicely(gp);
	scaleCube();
	gp=transform(gp);
	g.setColor(Color.red);
	g.fill(gp);
	g.setColor(Color.white);
	g.draw(gp);
    }

    public CubeEdge[] getEdges() {
	int d=M.C.S.val;
	int lim=(int)(Math.pow(2,d));
	int count=0;
	CubeEdge[] E=new CubeEdge[d*lim];
	for(int n=0;n<lim;++n) {
	    for(int nn=0;nn<d;++nn) {
		Complex[] Z=CubeMaker.edgeProject(d,n,nn,M.C.NAV);
		Color C=Color.white;
		if(M.C.COL.val==1) C=colorPick(nn,d);
		E[count]=new CubeEdge(Z,C,count);
		++count;
	    }
	}
	return E;
    }

    public void drawCube(Graphics2D g) {
	g.setStroke(new BasicStroke(M.C.THICK.val));
	Color C=Color.white;
	g.setColor(C);
	scaleCube();
	Path2D.Double gp=new Path2D.Double();
	CubeEdge[] E=getEdges();
	for(int i=0;i<E.length;++i) {
	   gp=E[i].toPath();
	   gp=transform(gp);
	   g.setColor(E[i].C);
	   g.draw(gp);
	}
	g.setStroke(new BasicStroke(1));
    }




    public static Color colorPick(int i,int d) {
	int step=511/d;
	if(i<d/2) return(new Color(step*i,0,255-step*i));
	int j=i-d/2;
	return(new Color(255-step*j,step*j,0));
    }





    public void mousePressed(MouseEvent e) { }
    public void mouseClicked(MouseEvent e) { 
	MouseData J=MouseData.process(e);
        if(J.mode==1)  scaleUp(J.X,0);
        if(J.mode==3)  scaleUp(J.X,1);
	repaint();
    }
     public void mouseReleased(MouseEvent e) {	 
     }

     public void mouseEntered(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}   

     public void mouseMoved(MouseEvent e) {}   
     public void mouseDragged(MouseEvent e) {
     }


}

